using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZXDT.DBUtility;
using System.Data;
using System.Data.SqlClient;

namespace ZXDT.CallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_Note
    /// </summary>
    public partial class T_Sys_Note
    {
        public T_Sys_Note()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int Nid)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_Note");
            strSql.Append(" where Nid=@Nid");
            SqlParameter[] parameters = {
					new SqlParameter("@Nid", SqlDbType.Int,4)
			};
            parameters[0].Value = Nid;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(ZXDT.CallCenter.Model.T_Sys_Note model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_Note(");
            strSql.Append("NTitle,NContent,Userid,NType,AccUser,AddTime)");
            strSql.Append(" values (");
            strSql.Append("@NTitle,@NContent,@Userid,@NType,@AccUser,@AddTime)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@NTitle", SqlDbType.VarChar,100),
					new SqlParameter("@NContent", SqlDbType.VarChar,500),
					new SqlParameter("@Userid", SqlDbType.Int,4),
					new SqlParameter("@NType", SqlDbType.Int,4),
					new SqlParameter("@AccUser", SqlDbType.VarChar,1000),
					new SqlParameter("@AddTime", SqlDbType.DateTime)};
            parameters[0].Value = model.NTitle;
            parameters[1].Value = model.NContent;
            parameters[2].Value = model.Userid;
            parameters[3].Value = model.NType;
            parameters[4].Value = model.AccUser;
            parameters[5].Value = model.AddTime;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(ZXDT.CallCenter.Model.T_Sys_Note model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_Note set ");
            strSql.Append("NTitle=@NTitle,");
            strSql.Append("NContent=@NContent,");
            strSql.Append("Userid=@Userid,");
            strSql.Append("NType=@NType,");
            strSql.Append("AccUser=@AccUser,");
            strSql.Append("AddTime=@AddTime");
            strSql.Append(" where Nid=@Nid");
            SqlParameter[] parameters = {
					new SqlParameter("@NTitle", SqlDbType.VarChar,100),
					new SqlParameter("@NContent", SqlDbType.VarChar,500),
					new SqlParameter("@Userid", SqlDbType.Int,4),
					new SqlParameter("@NType", SqlDbType.Int,4),
					new SqlParameter("@AccUser", SqlDbType.VarChar,1000),
					new SqlParameter("@AddTime", SqlDbType.DateTime),
					new SqlParameter("@Nid", SqlDbType.Int,4)};
            parameters[0].Value = model.NTitle;
            parameters[1].Value = model.NContent;
            parameters[2].Value = model.Userid;
            parameters[3].Value = model.NType;
            parameters[4].Value = model.AccUser;
            parameters[5].Value = model.AddTime;
            parameters[6].Value = model.Nid;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int Nid)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Note ");
            strSql.Append(" where Nid=@Nid");
            SqlParameter[] parameters = {
					new SqlParameter("@Nid", SqlDbType.Int,4)
			};
            parameters[0].Value = Nid;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string Nidlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_Note ");
            strSql.Append(" where Nid in (" + Nidlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Sys_Note GetModel(int Nid)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 Nid,NTitle,NContent,Userid,NType,AccUser,AddTime from T_Sys_Note ");
            strSql.Append(" where Nid=@Nid");
            SqlParameter[] parameters = {
					new SqlParameter("@Nid", SqlDbType.Int,4)
			};
            parameters[0].Value = Nid;

            ZXDT.CallCenter.Model.T_Sys_Note model = new ZXDT.CallCenter.Model.T_Sys_Note();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public ZXDT.CallCenter.Model.T_Sys_Note DataRowToModel(DataRow row)
        {
            ZXDT.CallCenter.Model.T_Sys_Note model = new ZXDT.CallCenter.Model.T_Sys_Note();
            if (row != null)
            {
                if (row["Nid"] != null && row["Nid"].ToString() != "")
                {
                    model.Nid = int.Parse(row["Nid"].ToString());
                }
                if (row["NTitle"] != null)
                {
                    model.NTitle = row["NTitle"].ToString();
                }
                if (row["NContent"] != null)
                {
                    model.NContent = row["NContent"].ToString();
                }
                if (row["Userid"] != null && row["Userid"].ToString() != "")
                {
                    model.Userid = int.Parse(row["Userid"].ToString());
                }
                if (row["NType"] != null && row["NType"].ToString() != "")
                {
                    model.NType = int.Parse(row["NType"].ToString());
                }
                if (row["AccUser"] != null)
                {
                    model.AccUser = row["AccUser"].ToString();
                }
                if (row["AddTime"] != null && row["AddTime"].ToString() != "")
                {
                    model.AddTime = DateTime.Parse(row["AddTime"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select Nid,NTitle,NContent,Userid,NType,AccUser,AddTime ");
            strSql.Append(" FROM T_Sys_Note ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" Nid,NTitle,NContent,Userid,NType,AccUser,AddTime ");
            strSql.Append(" FROM T_Sys_Note ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_Note ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.Nid desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_Note T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

       

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }



}
